#include "configure.h"
#include "mfinderapp.h"
#include "functions.h"

ConfBaseIcnWin::ConfBaseIcnWin(QWidget *parent, const char *name, char *icnpath)
     			   :QWidget(parent, name)
{
	struct dirent **namelist;
	int m;

	QFont font = QFont("Helvetica", 12);
	QFont fontbig = QFont("Helvetica", 18);
	QFont fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	setFont(font);

	QColor x = QColor(160, 164, 160);
	QColorGroup	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	setCaption("configure");
	
	sprintf(ipath, "%s", icnpath);
	
	titlebig = new QLabel(this, "titlebig");
	titlebig->setGeometry(20, 5, 300, 29);
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setFont(fontbig);
	titlebig->setText("Base Icons");
	titlebig->setAlignment(265);

	titl2 = new QLabel(this, "titl2");
	titl2->setGeometry(10, 78, 80, 15);
	titl2->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl2->setFont(font);
	titl2->setText("File");
	titl2->setAlignment(290);

	pixLabFile = new QLabel(this, "pixLabFile");
	pixLabFile->setGeometry(98, 43, 50, 50);
	pixLabFile->setFrameStyle(34);
	pixLabFile->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFile->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FIL, FALSE,
																				UNSELECT, FALSE));

	buttFile = new QPushButton(this, "buttFile");
	buttFile->setGeometry(160, 73, 50, 20);
	buttFile->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFile->setFont(font);
	buttFile->setText("change");
	connect(buttFile, SIGNAL(clicked()), SLOT(setFileIcn()));

	titl3 = new QLabel(this, "titl3");
	titl3->setGeometry(10, 133, 80, 15);
	titl3->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl3->setFont(font);
	titl3->setText("File link");
	titl3->setAlignment(290);

	pixLabFileLink = new QLabel(this, "pixLabFileLink");
	pixLabFileLink->setGeometry(98, 98, 50, 50);
	pixLabFileLink->setFrameStyle(34);
	pixLabFileLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFileLink->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FILLNK,
																		 FALSE, UNSELECT, FALSE));

	buttFileLnk = new QPushButton(this, "buttFileLnk");
	buttFileLnk->setGeometry(160, 128, 50, 20);
	buttFileLnk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileLnk->setFont(font);
	buttFileLnk->setText("change");
	connect(buttFileLnk, SIGNAL(clicked()), SLOT(setFileLnkIcn()));

	titl4 = new QLabel(this, "titl4");
	titl4->setGeometry(10, 188, 80, 15);
	titl4->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl4->setFont(font);
	titl4->setText("File exe");
	titl4->setAlignment(290);

	pixLabFileExe = new QLabel(this, "pixLabFileExe");
	pixLabFileExe->setGeometry(98, 153, 50, 50);
	pixLabFileExe->setFrameStyle(34);
	pixLabFileExe->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFileExe->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FILEXE,
																		 FALSE, UNSELECT, FALSE));

	buttFileExe = new QPushButton(this, "buttFileExe");
	buttFileExe->setGeometry(160, 183, 50, 20);
	buttFileExe->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileExe->setFont(font);
	buttFileExe->setText("change");
	connect(buttFileExe, SIGNAL(clicked()), SLOT(setFileExeIcn()));

	titl5 = new QLabel(this, "titl5");
	titl5->setGeometry(10, 243, 80, 15);
	titl5->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl5->setFont(font);
	titl5->setText("File exe link");
	titl5->setAlignment(290);

	pixLabFileExeLink = new QLabel(this, "pixLabFileExeLink");
	pixLabFileExeLink->setGeometry(98, 208, 50, 50);
	pixLabFileExeLink->setFrameStyle(34);
	pixLabFileExeLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFileExeLink->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", FILEXELNK,
																			 FALSE, UNSELECT, FALSE));

	buttFileExeLnk = new QPushButton(this, "buttFileExeLnk");
	buttFileExeLnk->setGeometry(160, 238, 50, 20);
	buttFileExeLnk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileExeLnk->setFont(font);
	buttFileExeLnk->setText("change");
	connect(buttFileExeLnk, SIGNAL(clicked()), SLOT(setFileExeLnkIcn()));

	titl6 = new QLabel(this, "titl6");
	titl6->setGeometry(10, 298, 80, 15);
	titl6->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl6->setFont(font);
	titl6->setText("Folder");
	titl6->setAlignment(290);

	pixLabFolder = new QLabel(this, "pixLabFolder");
	pixLabFolder->setGeometry(98, 263, 50, 50);
	pixLabFolder->setFrameStyle(34);
	pixLabFolder->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFolder->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", DR, FALSE,
																				 UNSELECT, FALSE));

	buttFold = new QPushButton(this, "buttFold");
	buttFold->setGeometry(160, 293, 50, 20);
	buttFold->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFold->setFont(font);
	buttFold->setText("change");
	connect(buttFold, SIGNAL(clicked()), SLOT(setFoldIcn()));

	titl7 = new QLabel(this, "titl7");
	titl7->setGeometry(10, 353, 80, 15);
	titl7->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl7->setFont(font);
	titl7->setText("Folder link");
	titl7->setAlignment(290);

	pixLabFolderLink = new QLabel(this, "pixLabFolderLink");
	pixLabFolderLink->setGeometry(98, 318, 50, 50);
	pixLabFolderLink->setFrameStyle(34);
	pixLabFolderLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixLabFolderLink->setPixmap(((mfinderapp *)qApp)->iconForFile(" ", " ", DRLNK,
																		 FALSE, UNSELECT, FALSE));

	buttFoldLink = new QPushButton(this, "buttFoldLink");
	buttFoldLink->setGeometry(160, 348, 50, 20);
	buttFoldLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFoldLink->setFont(font);
	buttFoldLink->setText("change");
	connect(buttFoldLink, SIGNAL(clicked()), SLOT(setFoldLinkIcn()));

	butOk = new QPushButton(this, "butOk");
	butOk->setGeometry(300, 395, 80, 30);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butOk->setFont(font);
	butOk->setText("OK");
	connect(butOk, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(makeNewReqIconList()));

	butCancel = new QPushButton(this, "butCancel");
	butCancel->setGeometry(205, 395, 80, 30);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butCancel->setFont(font);
	butCancel->setText("Cancel");
	connect(butCancel, SIGNAL(clicked()), SLOT(Close()));

	pixToChangeLab = new QLabel(this, "pixToChangeLab");
	pixToChangeLab->setGeometry(283, 173, 50, 50);
	pixToChangeLab->setFrameStyle(34);
	pixToChangeLab->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	reqIcList = new QListBox(this, "reqIcList");
	reqIcList->setGeometry(235, 45, 145, 120);
	reqIcList->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	reqIcList->setFont(font);
	reqIcList->setFrameStyle(51);
	reqIcList->setLineWidth(2);
	reqIcList->setMultiSelection(FALSE);
	connect(reqIcList, SIGNAL(highlighted(const char*)), SLOT(changeIcnToChange(const char*)));
	m = scandir(ipath, &namelist, 0, alphasort);
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0
               		&& strcmp(namelist[i]->d_name, "..") != 0) {
      	reqIcList->insertItem(namelist[i]->d_name);
		}
	}
	reqIcList->setSelected(0, TRUE);
	
	setFixedSize(400, 440);
}

ConfBaseIcnWin::~ConfBaseIcnWin()
{

}

void ConfBaseIcnWin::setFileIcn()
{
	strcpy(icnFilePath, lastPathComponent(icntochangepath));
	pixLabFile->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFileLnkIcn()
{
	strcpy(icnFileLnkPath, lastPathComponent(icntochangepath));
	pixLabFileLink->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFileExeIcn()
{
	strcpy(icnFileExePath, lastPathComponent(icntochangepath));
	pixLabFileExe->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFileExeLnkIcn()
{
	strcpy(icnFileExeLnkPath, lastPathComponent(icntochangepath));
	pixLabFileExeLink->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFoldIcn()
{
	strcpy(icnFoldPath, lastPathComponent(icntochangepath));
	pixLabFolder->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::setFoldLinkIcn()
{
	strcpy(icnFoldLnkPath, lastPathComponent(icntochangepath));
	pixLabFolderLink->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::Close()
{
	close();
}

void ConfBaseIcnWin::changeIcnToChange(const char *selname)
{
	sprintf(icntochangepath, "%s/%s", ipath, selname);
	pixToChangeLab->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfBaseIcnWin::resizeEvent(QResizeEvent *)
{
	((mfinderapp *)qApp)->centreDialogOnScreen(this);
}

void ConfBaseIcnWin::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 34, width(), 34);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 35, width(), 35);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 383, width(), 383);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 384, width(), 384);
	p.end();
}


ConfFilesIcnWin::ConfFilesIcnWin(QWidget *parent, const char *name, 
					char *icnpath, QList<char> prefsufflist, QList<char> nameslist)
					 :QWidget(parent, name)
{
	char buff[MAX_NAME_LEN] = "";
	struct dirent **namelist;
	int m;

	QFont font = QFont("Helvetica", 12);
	QFont fontbig = QFont("Helvetica", 18);
	QFont fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	setFont(font);

	QColor x = QColor(160, 164, 160);
	QColorGroup	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	QColorGroup grigio = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), QColor(QRgb(6250335)), white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	setCaption("configure");

	sprintf(ipath, "%s", icnpath);
	
	keyslist.setAutoDelete(TRUE);
	icnnamelist.setAutoDelete(TRUE);

	for(int i = 0; i < prefsufflist.count(); i++) {
		keyslist.append(new char[strlen(prefsufflist.at(i))+1]);
		strcpy(keyslist.current(), prefsufflist.at(i));
	}
	for(int i = 0; i < nameslist.count(); i++) {
		icnnamelist.append(new char[strlen(nameslist.at(i))+1]);
		strcpy(icnnamelist.current(), nameslist.at(i));
	}
	
	titlebig = new QLabel(this, "titlebig");
	titlebig->setGeometry(15, 5, 300, 30);
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setFont(fontbig);
	titlebig->setText("Files Icons");
	titlebig->setAlignment(265);

// ----------------------- Prefix ---------------------------
	titlpref = new QLabel(this, "titlpref");
	titlpref->setGeometry(15, 50, 80, 15);
	titlpref->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlpref->setFont(font);
	titlpref->setAlignment(292);
	titlpref->setText("Prefix");

	pixlabpref = new QLabel(this, "pixlabpref");
	pixlabpref->setGeometry(29, 188, 54, 54);
	pixlabpref->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixlabpref->setFrameStyle(34);

	prefslistbox = new QListBox(this, "prefslistbox");
	prefslistbox->setGeometry(15, 70, 80, 110);
	prefslistbox->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	prefslistbox->setFont(font);
	prefslistbox->setFrameStyle(51);
	prefslistbox->setLineWidth(2);
	prefslistbox->setMultiSelection(FALSE);
	connect(prefslistbox, SIGNAL(highlighted(const char*)), SLOT(showIconForPrefix(const char*)));
	for(int i = 0; i < keyslist.count(); i++) {
		if(keyslist.at(i)[0] != '*') {
			sprintf(buff, "");
			int j;
			for(j = 0; j < strlen(keyslist.at(i))-1; j++)
				buff[j] = keyslist.at(i)[j];
			buff[j] = '\0';
			prefslistbox->insertItem(buff);
		}
	}
	prefslistbox->setSelected(0, TRUE);

	buttchngpreficn = new QPushButton(this, "buttchngpreficn");
	buttchngpreficn->setGeometry(31, 245, 51, 20);
	buttchngpreficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttchngpreficn->setFont(font);	
	buttchngpreficn->setText("change");
	connect(buttchngpreficn, SIGNAL(clicked()), SLOT(changeIconForPrefix()));

	buttrempreficn = new QPushButton(this, "buttrempreficn");
	buttrempreficn->setGeometry(30, 295, 51, 20);
	buttrempreficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttrempreficn->setFont(font);		
	buttrempreficn->setText("remove");
	connect(buttrempreficn, SIGNAL(clicked()), SLOT(removePrefix()));

	prefedit = new QLineEdit(this, "prefedit");
	prefedit->setGeometry(15, 345, 80, 20);
	prefedit->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	prefedit->setFont(font);		
	prefedit->setFrame(TRUE);
	prefedit->setText("");

	buttaddpreficn = new QPushButton(this, "buttaddpreficn");
	buttaddpreficn->setGeometry(30, 370, 51, 20);
	buttaddpreficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttaddpreficn->setFont(font);		
	buttaddpreficn->setText("add");
	connect(buttaddpreficn, SIGNAL(clicked()), SLOT(addPrefix()));

// ----------------------- Suffix ---------------------------
	titlsuff = new QLabel(this, "titlsuff");
	titlsuff->setGeometry(105, 50, 80, 15);
	titlsuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlsuff->setFont(font);		
	titlsuff->setAlignment(292);
	titlsuff->setText("Suffix");

	pixlabsuff = new QLabel(this, "pixlabsuff");
	pixlabsuff->setGeometry(119, 188, 54, 54);
	pixlabsuff->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixlabsuff->setFrameStyle(34);

	suffslistbox = new QListBox(this, "suffslistbox");
	suffslistbox->setGeometry(105, 70, 80, 110);
	suffslistbox->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	suffslistbox->setFont(font);	
	suffslistbox->setFrameStyle(51);
	suffslistbox->setLineWidth(2);
	suffslistbox->setMultiSelection(FALSE);
	connect(suffslistbox, SIGNAL(highlighted(const char*)), SLOT(showIconForSuffix(const char*)));
	for(int i = 0; i < keyslist.count(); i++) {
		if(keyslist.at(i)[0] == '*') {
			sprintf(buff, "");
			buff[0] = '.';
			int j;
			for(j = 1; j < strlen(keyslist.at(i)); j++)
				buff[j] = prefsufflist.at(i)[j];
			buff[j] = '\0';
			suffslistbox->insertItem(buff);
		}
	}
	suffslistbox->setSelected(0, TRUE);

	buttchngsufficn = new QPushButton(this, "buttchngsufficn");
	buttchngsufficn->setGeometry(121, 245, 51, 20);
	buttchngsufficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttchngsufficn->setFont(font);			
	buttchngsufficn->setText("change");
	connect(buttchngsufficn, SIGNAL(clicked()), SLOT(changeIconForSuffix()));
	
	buttremsuffcn = new QPushButton(this, "buttremsuffcn");
	buttremsuffcn->setGeometry(120, 295, 51, 20);
	buttremsuffcn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttremsuffcn->setFont(font);			
	buttremsuffcn->setText("remove");
	connect(buttremsuffcn, SIGNAL(clicked()), SLOT(removeSuffix()));

	suffedit = new QLineEdit(this, "LineEdit_2");
	suffedit->setGeometry(105, 345, 80, 20);
	suffedit->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	suffedit->setFont(font);			
	suffedit->setFrame(TRUE);
	suffedit->setText("");

	buttaddsufficn = new QPushButton(this, "buttaddsufficn");
	buttaddsufficn->setGeometry(120, 370, 51, 20);
	buttaddsufficn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttaddsufficn->setFont(font);			
	buttaddsufficn->setText("add");
	connect(buttaddsufficn, SIGNAL(clicked()), SLOT(addSuffix()));

// ----------------------- New Icon ---------------------------
	titlnewicon = new QLabel(this, "titlnewicon");
	titlnewicon->setGeometry(195, 50, 120, 15);
	titlnewicon->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlnewicon->setFont(font);				
	titlnewicon->setAlignment(292);
	titlnewicon->setText("New Icon");

	pixlabnewicon = new QLabel(this, "pixlabnewicon");
	pixlabnewicon->setGeometry(227, 186, 54, 54);
	pixlabnewicon->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	pixlabnewicon->setFrameStyle(34);

	iconsnameslist = new QListBox(this, "iconsnameslist");
	iconsnameslist->setGeometry(195, 70, 120, 110);
	iconsnameslist->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	iconsnameslist->setFont(font);				
	iconsnameslist->setFrameStyle(51);
	iconsnameslist->setLineWidth(2);
	iconsnameslist->setMultiSelection(FALSE);
	connect(iconsnameslist, SIGNAL(highlighted(const char*)), SLOT(showNewIcon(const char*)));
	m = scandir(ipath, &namelist, 0, alphasort);
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0
               		&& strcmp(namelist[i]->d_name, "..") != 0) {
      	iconsnameslist->insertItem(namelist[i]->d_name);
		}
	}
	iconsnameslist->setSelected(0, TRUE);

// ----------------------- Expl Labels ---------------------------
	changeexpl = new QLabel(this, "changeexpl");
	changeexpl->setGeometry(31, 270, 140, 15);
	changeexpl->setFont(font);	
	changeexpl->setPalette(QPalette(grigio, grigio, grigio));
	changeexpl->setAlignment(289);
	changeexpl->setText("Change the current icon");

	removeexpl = new QLabel(this, "removeexpl");
	removeexpl->setGeometry(25, 320, 150, 15);
	removeexpl->setFont(font);	
	removeexpl->setPalette(QPalette(grigio, grigio, grigio));
	removeexpl->setAlignment(289);
	removeexpl->setText("Remove this prefix or suffix");

	addexpl = new QLabel(this, "addexpl");
	addexpl->setGeometry(29, 395, 143, 15);
	addexpl->setFont(font);				
	addexpl->setPalette(QPalette(grigio, grigio, grigio));
	addexpl->setAlignment(289);
	addexpl->setText("Add a new prefix or suffix");

// ----------------------- OK and Cancel ---------------------------
	butOk = new QPushButton(this, "butOk");
	butOk->setGeometry(235, 440, 80, 30);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butOk->setFont(font);			
	butOk->setText("OK");
	connect(butOk, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(makeNewIconList()));

	butCancel = new QPushButton(this, "butCancel");
	butCancel->setGeometry(145, 440, 80, 30);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butCancel->setFont(font);			
	butCancel->setText("Cancel");
	connect(butCancel, SIGNAL(clicked()), SLOT(Close()));

	setFixedSize(330,485);
}

ConfFilesIcnWin::~ConfFilesIcnWin()
{
	icnnamelist.clear();
	keyslist.clear();
}

void ConfFilesIcnWin::Close()
{
	close();
}

void ConfFilesIcnWin::showIconForPrefix(const char *pref)
{
	char buff[MAX_NAME_LEN] = "", icpath[MAX_PATH_LEN] = "";
	int i, ind = -1;
	
	strcpy(currpref, pref);	

	sprintf(buff, "%s*", pref);
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
	
	sprintf(icpath, "%s/%s", ipath, icnnamelist.at(ind));
	pixlabpref->setPixmap(QPixmap(icpath, "XPM"));
}

void ConfFilesIcnWin::changeIconForPrefix()
{
	char iname[MAX_NAME_LEN] = "", buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	sprintf(iname, "%s", lastPathComponent(icntochangepath));

	sprintf(buff, "%s*", currpref);
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;

	icnnamelist.remove(ind);
	icnnamelist.insert(ind, new char[strlen(iname)+1]);
	strcpy(icnnamelist.current(), iname);
	showIconForPrefix(currpref);
}

void ConfFilesIcnWin::addPrefix()
{
	char err[256] = "", buff[MAX_NAME_LEN] = "", buff2[MAX_NAME_LEN] = "";
	int sel;
	bool iserr = FALSE;
	
	if(!prefedit->text()) 
		return;
	sprintf(buff, "%s", prefedit->text());
	for(int i = 0; i < strlen(buff); i++) {
		if(buff[i] == '.' && i > 0) {
			sprintf(err, "The prefix can't contain a \".\"!");
			iserr = TRUE;
		}
		if(buff[i] == ' ') {
			sprintf(err, "The prefix can't contain a space!");
			iserr = TRUE;
		}
		if(buff[i] == '/') {
			sprintf(err, "The prefix can't contain a \"/\"!");
			iserr = TRUE;
		}
		if(buff[i] == '*') {
			sprintf(err, "The prefix can't contain a \"*\"!");
			iserr = TRUE;
		}
	}		
	if(!iserr) {  
		sprintf(buff2, "%s*", buff);
		for(int i = 0; i < keyslist.count(); i++) {
			if(strcmp(buff2, keyslist.at(i)) == 0) {
				sprintf(err, "This prefix is already in use!");
				iserr = TRUE;
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
				dialog->exec();
				break;
			}
		} 
		if(!iserr) {
			prefslistbox->insertItem(buff);
			keyslist.append(new char[strlen(buff2)+1]);
			strcpy(keyslist.current(), buff2);
			sprintf(buff, "%s", lastPathComponent(icntochangepath));	
			icnnamelist.append(new char[strlen(buff)+1]);
			strcpy(icnnamelist.current(), buff);
			prefslistbox->setCurrentItem(prefslistbox->count()-1);
		}
	} else {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		dialog->exec();
	}
}

void ConfFilesIcnWin::removePrefix()
{
	char buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	sprintf(buff, "%s*", currpref);
	for(i = 0; i < keyslist.count(); i++) 
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
	keyslist.remove(ind);
	icnnamelist.remove(ind);
	
	for(i = 0; i < prefslistbox->count(); i++) 
		if(strcmp(prefslistbox->text(i), currpref) == 0)
			ind = i;	
	prefslistbox->removeItem(ind);
}

void ConfFilesIcnWin::showIconForSuffix(const char *suff)
{
	char buff[MAX_NAME_LEN] = "", icpath[MAX_PATH_LEN] = "";
	int i, ind = -1;

	strcpy(currsuff, suff);	
	
	buff[0] = '*';
	for(i = 1; i < strlen(suff); i++)
		buff[i] = suff[i];
	buff[i] = '\0';
	
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
	
	sprintf(icpath, "%s/%s", ipath, icnnamelist.at(ind));
	pixlabsuff->setPixmap(QPixmap(icpath, "XPM"));
}

void ConfFilesIcnWin::changeIconForSuffix()
{
	char iname[MAX_NAME_LEN] = "", buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	sprintf(iname, "%s", lastPathComponent(icntochangepath));

	buff[0] = '*';
	for(i = 1; i < strlen(currsuff); i++)
		buff[i] = currsuff[i];
	buff[i] = '\0';
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;

	icnnamelist.remove(ind);
	icnnamelist.insert(ind, new char[strlen(iname)+1]);
	strcpy(icnnamelist.current(), iname);
	showIconForSuffix(currsuff);
}

void ConfFilesIcnWin::addSuffix()
{
	char err[256] = "", buff[MAX_NAME_LEN] = "", buff2[MAX_NAME_LEN] = "";
	int i;
	bool iserr = FALSE;
	
	sprintf(buff, "%s", suffedit->text());
	if(buff[0] != '.') {
		sprintf(err, "The first char must be a \".\"!");
		iserr = TRUE;	
	}
	for(i = 1; i < strlen(buff); i++) {
		if(buff[i] == '.') {
			sprintf(err, "The suffix can contain only a \".\"!");
			iserr = TRUE;
		}
	}
	for(i = 0; i < strlen(buff); i++) {
		if(buff[i] == ' ') {
			sprintf(err, "The suffix can't contain a space!");
			iserr = TRUE;
		}
		if(buff[i] == '/') {
			sprintf(err, "The suffix can't contain a \"/\"!");
			iserr = TRUE;
		}
		if(buff[i] == '*') {
			sprintf(err, "The suffix can't contain a \"*\"!");
			iserr = TRUE;
		}
	}		
	if(!iserr) {
		sprintf(buff2, "%s", buff);
		buff2[0] = '*';	
		for(i = 0; i < keyslist.count(); i++) {
			if(strcmp(buff2, keyslist.at(i)) == 0) {
				sprintf(err, "This suffix is already in use!");
				iserr = TRUE;
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
				dialog->exec();
				break;
			}
		}
		if(!iserr) {
			suffslistbox->insertItem(buff);
			keyslist.append(new char[strlen(buff2)+1]);
			strcpy(keyslist.current(), buff2);
			sprintf(buff, "%s", lastPathComponent(icntochangepath));	
			icnnamelist.append(new char[strlen(buff)+1]);
			strcpy(icnnamelist.current(), buff);
			suffslistbox->setCurrentItem(suffslistbox->count()-1);
		}
	} else {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		dialog->exec();
		return;
	}
}

void ConfFilesIcnWin::removeSuffix()
{
	char buff[MAX_NAME_LEN] = "";
	int i, ind = -1;

	buff[0] = '*';
	for(i = 1; i < strlen(currsuff); i++)
		buff[i] = currsuff[i];
	buff[i] = '\0';
	
	for(i = 0; i < keyslist.count(); i++)
		if(strcmp(keyslist.at(i), buff) == 0)
			ind = i;
		
	keyslist.remove(ind);
	icnnamelist.remove(ind);
	
	for(i = 0; i < suffslistbox->count(); i++) 
		if(strcmp(suffslistbox->text(i), currsuff) == 0)
			ind = i;	
	suffslistbox->removeItem(ind);
}

void ConfFilesIcnWin::showNewIcon(const char *selname)
{
	sprintf(icntochangepath, "%s/%s", ipath, selname);
	pixlabnewicon->setPixmap(QPixmap(icntochangepath, "XPM"));
}

void ConfFilesIcnWin::resizeEvent(QResizeEvent *)
{
	((mfinderapp *)qApp)->centreDialogOnScreen(this);
}

void ConfFilesIcnWin::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 38, width(), 38);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 39, width(), 39);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 422, width(), 422);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 423, width(), 423);
	p.end();
}
