#ifndef CONFIG_H
#define CONFIG_H

#include "common.h"
#include "dialogs.h"
#include <qmlined.h> 
#include <qlined.h> 
#include <qpushbt.h>
#include <qpixmap.h> 
#include <qbitmap.h> 
#include <qimage.h> 
#include <qlabel.h>
#include <qframe.h> 
#include <qlistbox.h> 
#include <qcheckbox.h> 
#include <qtablevw.h> 
#include <qcolor.h>
#include <qfont.h> 

class ConfBaseIcnWin : public QWidget
{
	Q_OBJECT
public:

	ConfBaseIcnWin(QWidget *parent=0, const char *name=0, char *icnpath=0);

	~ConfBaseIcnWin();

	char ipath[MAX_PATH_LEN];
	char icntochangepath[MAX_PATH_LEN];
	
	QLabel* titlebig;
	
	QLabel* titl2;
	QLabel* pixLabFile;
	QPushButton* buttFile;
	char icnFilePath[MAX_PATH_LEN];
	QLabel* titl3;
	QLabel* pixLabFileLink;
	QPushButton* buttFileLnk;
	char icnFileLnkPath[MAX_PATH_LEN];
	QLabel* titl4;
	QLabel* pixLabFileExe;
	QPushButton* buttFileExe;
	char icnFileExePath[MAX_PATH_LEN];
	QLabel* titl5;
	QLabel* pixLabFileExeLink;
	QPushButton* buttFileExeLnk;
	char icnFileExeLnkPath[MAX_PATH_LEN];
	QLabel* titl6;	
	QLabel* pixLabFolder;
	QPushButton* buttFold;
	char icnFoldPath[MAX_PATH_LEN];
	QLabel* titl7;
	QLabel* pixLabFolderLink;
	QPushButton* buttFoldLink;
	char icnFoldLnkPath[MAX_PATH_LEN];

	QListBox* reqIcList;
	QLabel* pixToChangeLab;

	QPushButton* butOk;
	QPushButton* butCancel;

public slots:
	void setFileLnkIcn();
	void setFileIcn();
	void setFoldLinkIcn();
	void setFileExeIcn();
	void Close();
	void setFileExeLnkIcn();
	void changeIcnToChange(const char*);
	void setFoldIcn();

protected:
	void paintEvent(QPaintEvent *);
	void resizeEvent(QResizeEvent *);

};

class ConfFilesIcnWin : public QWidget
{
	Q_OBJECT
public:

	ConfFilesIcnWin(QWidget *parent=0, const char *name=0, char *icnpath=0, 
 												QList<char> prefsufflist=QList<char>(), 
 														QList<char> nameslist=QList<char>());

	~ConfFilesIcnWin();

	char ipath[MAX_PATH_LEN];
	char icntochangepath[MAX_PATH_LEN];
	char currpref[MAX_NAME_LEN];
	char currsuff[MAX_NAME_LEN];
	Dialog *dialog;
	QList<char> icnnamelist; 
	QList<char> keyslist; 

	QLabel* titlebig;
	
	QLabel* titlpref;
	QListBox* prefslistbox;
	QLabel* pixlabpref;
	QPushButton* buttchngpreficn;
	QPushButton* buttrempreficn;
	QLineEdit* prefedit;
	QPushButton* buttaddpreficn;

	QLabel* titlsuff;
	QListBox* suffslistbox;
	QLabel* pixlabsuff;
	QPushButton* buttchngsufficn;
	QPushButton* buttremsuffcn;
	QLineEdit* suffedit;
	QPushButton* buttaddsufficn;

	QLabel* titlnewicon;
	QListBox* iconsnameslist;
	QLabel* pixlabnewicon;

	QLabel* changeexpl;
	QLabel* removeexpl;
	QLabel* addexpl;
	
	QPushButton* butOk;
	QPushButton* butCancel;

public slots:
	void showIconForPrefix(const char*);
	void removeSuffix();
	void Close();
	void showIconForSuffix(const char*);
	void showNewIcon(const char*);
	void addPrefix();
	void changeIconForPrefix();
	void addSuffix();
	void removePrefix();
	void changeIconForSuffix();

protected:
	void paintEvent(QPaintEvent *);
	void resizeEvent(QResizeEvent *);

};

#endif
