#ifndef DESKOBJ_H
#define DESKOBJ_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qimage.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qpalette.h> 
#include <qfontmet.h> 
#include <qfont.h> 
#include <qlabel.h> 
#include <qdragobject.h>
#include <qdropsite.h>
#include <qstrlist.h> 
#include "dialogs.h"
#include "common.h"
#include "popup.h"

class FileObj;
class FileListObj;

class DeskObj : public QWidget, QDropSite
{
	Q_OBJECT
public:
	DeskObj(QWidget *parent=0, const char *fullpath=0, const char *path=0,
									 const char *name=0, int type=-1, int x=0, int y=0);
	~DeskObj();

	void calcDim();
	void setMyRefObj(QWidget*);
	void unsetMyRefObj();
	void Select(bool);
	void Unselect(bool);
	void SelOpen(bool);
	void UnselOpen(bool);
	void Close(bool);
	void updateMyIcon();
	QPixmap prepDragPix();
	Popup* createPopup();
	
	char myName[MAX_NAME_LEN];
	char myPath[MAX_PATH_LEN];
	char myFullPath[MAX_PATH_LEN];
	char myAppName[256];	
	int myType;

	bool isDir;

	bool isSelect;
	bool isOpen;
	bool isOpenUnsl;
	bool isOpenLocal;

	FileListObj *myreflistobj;
	FileObj *myrefobj;
	bool ismyobj;
	bool fromlistview;
	bool havecustomicon;
	
	QPixmap icona;
	QBitmap mask;
	QPalette pnorm, pinv;
	QFont font;
	Popup *popupMenu;

	QUrlDrag *urlDragObj;

	int pxIcn, pxLabel;
	int x, y;
	int textXOffset, textYOffset, pixmapXOffset, pixmapYOffset;
	int xOffset, yOffset;
	int wdt, hgt;
	
signals:
		
public slots:
	void deleteFromPopUp();	
	
protected:
	void resizeEvent(QResizeEvent *);
	void mousePressEvent(QMouseEvent *);
	void mouseDoubleClickEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);

	void dragEnterEvent(QDragEnterEvent *);
	void dragLeaveEvent(QDragLeaveEvent *);
	void dropEvent(QDropEvent *);
	
	void paintEvent(QPaintEvent *);
	
private:
	int dragdelay;
	
};

#endif // DESKOBJ_H
