#ifndef DIALOGS_H
#define DIALOGS_H

#include <qdialog.h> 
#include <qpushbt.h> 
#include <qlined.h>
#include <qmlined.h> 
#include <qchkbox.h> 
#include <qbttngrp.h> 
#include <qlayout.h> 
#include <qpushbt.h> 
#include <qlabel.h>
#include <qframe.h> 
#include <qpixmap.h>
#include <qimage.h>
#include <qlabel.h>
#include <qlistbox.h> 
#include <qfont.h> 
#include <qfontmet.h> 
#include <qwidget.h>
#include <qstring.h>
#include <qpainter.h>
#include <qprogressbar.h> 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

class Dialog : public QDialog
{
	Q_OBJECT
public:
	Dialog(QWidget *parent=0, const char *name=0, bool modal=FALSE, 
					WFlags f=0, bool istitbig=FALSE, bool istxtfield=FALSE, 
				 	bool isedfield=FALSE, bool iscancbutt=FALSE, 
				 	const char *contents=0);

   QColor x;
	QColorGroup CGnorm;
	QFont font, fontbold, fontbig;
	int sepor, sepv;
	QLabel *textfield, *titlebig;
	QLineEdit *editfield;
	QPushButton *ok, *cancel;

	bool istitbig, istxtfield, isedfield, iscancbutt;
	int frstlinv, seclinv;
	 	
protected:
	void resizeEvent(QResizeEvent *);
	void paintEvent(QPaintEvent *);

};

class DlogOpenAt : public QDialog
{
	Q_OBJECT
public:
	DlogOpenAt(QWidget *parent=0, const char *name=0);

   QColor x;
	QColorGroup CGnorm;
	QFont font, fontbig;
	QLabel *titlebig;
	QLineEdit *editfield;
	QPushButton *ok, *cancel;

	void completeEditLine();
	
protected:
	void resizeEvent(QResizeEvent *);
	void paintEvent(QPaintEvent *);
	bool eventFilter(QObject *, QEvent *);

};

class DialogCopy : public QWidget
{
	Q_OBJECT
public:
	DialogCopy(QWidget *parent=0, const char *name=0);

   QColor x;
	QColorGroup CGnorm;
	QFont font, fontbold, fontbig;
	QLabel *titlebig;
	QProgressBar *pbar;

public slots:
	 	
protected:
	void paintEvent(QPaintEvent *);
	void resizeEvent(QResizeEvent *);

};

class StrtScrn : public QWidget
{
	Q_OBJECT
public:
	StrtScrn(QWidget *parent=0, const char *name=0, const char *icnpath=0);

	QFont font, fontbold, fontbig;
	QLabel *statusfield, *explfield, *titlebig;
	char expl1[128], expl2[128];
	QProgressBar *pbar;
	QPixmap backpix;
	
public slots:
	 	
protected:
	void resizeEvent(QResizeEvent *);
	
};

class WMFInfo : public QWidget
{
	Q_OBJECT
public:
	WMFInfo(QWidget *parent=0, const char *name=0, const char *icnpath=0);
	void close();

   QColor x;
	QColorGroup CGnorm;
	QFont font, fontbold, fontbig;
	QLabel *statusfield, *explfield, *titlebig;
	QPixmap backpix;
	
public slots:
	 	
protected:
	void resizeEvent(QResizeEvent *);

};

class HelpWin : public QWidget
{
	Q_OBJECT
public:
	HelpWin(QWidget *parent=0, const char *name=0);
	void close();

	QFont font, fontbold, fontbig;
	QMultiLineEdit *mlefield;
	
public slots:
	 	
protected:
	void paintEvent(QPaintEvent *);
	void resizeEvent(QResizeEvent *);

private:
 	char *help_buf;
 	 
};

class ChooseAnIcnDlg : public QDialog
{
	Q_OBJECT
public:
	ChooseAnIcnDlg(QWidget *parent, const char *name,
			char *iconPath, char *icname, char *errmsg, bool iscancbutt);

	QColor x;
	QColorGroup	CGnorm;
	QFont font, fontbold, fontbig;
	QLabel *titlebig, *messglab, *IcnLab;
	QLineEdit *namIcnEd;
	QListBox *icnList;
	QPixmap Icona;
	char icnPath[512];
	char icnName[128];
	
	QPushButton *butCancel, *butOk;
	
signals:
	
public slots:
	void setNameIcn(const char *);
	void changeIcn(const char *icname);
	
protected:
	void paintEvent(QPaintEvent *);
	void resizeEvent(QResizeEvent *);

private:

};

#endif
