#ifndef FILEOBJ_H
#define FILEOBJ_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qpalette.h> 
#include <qfontmet.h> 
#include <qfont.h> 
#include <qlabel.h> 
#include <qdragobject.h>
#include <qdropsite.h>
#include <qstrlist.h> 
#include <grp.h>
#include <sys/types.h>
#include "deskobj.h"
#include "common.h"
#include "popup.h"
#include "dialogs.h"

class ObjsFrame;

class FileObj : public QWidget, QDropSite
{
	Q_OBJECT
public:
	FileObj(QWidget *parent=0, const char *path=0,
									const char *name=0, int type=-1, int viewtype=0);
	~FileObj();
		
	char myName[MAX_NAME_LEN];
	char myPath[MAX_PATH_LEN];
	char myFullPath[MAX_PATH_LEN];
	char myLinkTo[MAX_PATH_LEN];
	char myAppName[256];	
	int myType;
	int viewtype;
	
	ObjsFrame *myobjsframe;
	DeskObj *mydeskobj;
	bool isDir;

	bool isSelect;
	bool isOpen;
	bool isOpenUnsl;
	bool isOpenLocal;
	bool ismydeskobj;
	bool mustdrawselrect;
	bool havecustomicon;

	QPixmap icona;
	QLabel *label;
	QPalette pnorm, pinv;
	QFont font;
	Popup *popupMenu;
	Dialog *dialog;
	QRect SelRect, r1o, r2o, r1v, r2v;
	QUrlDrag *urlDragObj;
	
	void Select(bool);
	void Unselect(bool);
	void SelOpen(bool);
	void UnselOpen(bool);
	void Open(QMouseEvent *);
	void Close(bool);
	void adjustLabelPosition();
	char *cutFileLabelText(char *);
	void updateMyData();
	void updateMyIcon();
	void drawSelRect(QRect, bool);		
	void setMyDeskObj(DeskObj*);
	void unsetMyDeskObj();
	QPixmap prepDragPix();
	Popup* createPopup();
	void InfoObj();
		
signals:
		
public slots:
	void openFromPopUp();
	void renameFromPopUp();
	void infoFromPopUp();
	void editFromPopUp();
	void openWithFromPopUp();
	void duplicateFromPopUp();
	void deleteFromPopUp();	
	
protected:
	void moveEvent(QMoveEvent *);
	void mousePressEvent(QMouseEvent *);
	void mouseDoubleClickEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);

	void dragEnterEvent(QDragEnterEvent *);
	void dragLeaveEvent(QDragLeaveEvent *);
	void dropEvent(QDropEvent *);
	
	bool eventFilter(QObject *, QEvent *);
	void paintEvent(QPaintEvent *);
	
private:
	int dragdelay;
	
};

#endif // FILEOBJ_H
