#include "mfinderapp.h"
#include "functions.h"
#include <pwd.h>
#include <grp.h>

extern char confdir[];
extern char iconsPath[];		 	
extern char appsPath[];

char ERR[512] = "";
static char *NOERR = "noerr";
static char *NAMUSE = "This name is already in use!\n";
static char *NODEL = "You dont have write permission\nfor some elements.\n"
    "These elements were not deleted!\n";
static char *NOCOPY = "You dont have write permission\nfor some elements.\n"
    "These elements were not copied!\n";
static char *SOUCDEST = "Source and destination \nare identical!\n";
static char *SUBPATH = "The destination directory\n"
						"is a subpath of the source directory!\n";
static char *FATHRWSUB = "You can't sobstitute a directory\nwith its content!\n";
static char *DIFTYPE = "You can't sobstitute objects\nof different type!\n";
static char *SYSERR = "System Error!\n";	

#define PSIZE 4
#define PIECES ((64/PSIZE)*(64/PSIZE))

#define ASKTOCONNECT 0
#define NOTIFICATIONREQ 1
#define SERVERREPLY 2
#define OPENAPP 3
#define OPENFILE 4
#define OPENFILEWITHAPP 5
#define STARTXTERM 6
#define FILEOPS 7

char custedit[256] = "";

int QPathList::compareItems(GCI item1, GCI item2)
{
	char *f1 = (char *)item1;
	char *f2 = (char *)item2;
		
	if(strlen(deleteLastPathComponent(f1)) < strlen(deleteLastPathComponent(f2)))
		return -1;
	if(strlen(deleteLastPathComponent(f1)) > strlen(deleteLastPathComponent(f2)))
		return 1;
		
	return 0;
}

void mfinderapp::fileopsErr(char *title, char *error)
{
	dialog = new Dialog(0L, title, TRUE, 0, TRUE, TRUE, FALSE, FALSE, error);
	int m = dialog->exec();
}

void mfinderapp::moveOrCopy(QStrList fileslist, char *topath, QWidget *droptarget)
{
	QPathList sortedlist;
	QStrList querylist;
	char buff[MAX_PATH_LEN] = "";
	char frompath[MAX_PATH_LEN] = "";
	char *query;
	int i = 0, count = 0, len = 0;
	
	dndok	= TRUE;
	
	if(fileListDragObj != NULL)
		fileListDragObj->urlDragObj->~QUrlDrag();
	if(fileDragObj != NULL)
		fileDragObj->urlDragObj->~QUrlDrag();
	if(deskDragObj != NULL)
		deskDragObj->urlDragObj->~QUrlDrag();
	
	count = fileslist.count();
	if(count == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	
	if(access(topath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", topath);
		fileopsErr("Error", ERR);
		dndok	= FALSE;
		goto cleardnd;
	}
	
	for(i = 0; i < count; i++)
		sortedlist.inSort(fileslist.at(i));
		
	len = strlen(deleteLastPathComponent(sortedlist.at(0)));
	i = 0;
	while(strlen(deleteLastPathComponent(sortedlist.at(i))) == len) {
		querylist.append(sortedlist.at(i));
		i++;
		if(i == count)
			break;
	}
	
	if(count > querylist.count()) {
		sprintf(ERR, "You can't do this from multiple paths!\n");
		fileopsErr("Error", ERR);
		dndok	= FALSE;
		goto cleardnd;
	}
	
	count = querylist.count();
	
	sprintf(frompath, "%s", deleteLastPathComponent(querylist.at(0)));
	if(strcmp(frompath, topath) == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	if(strcmp(topath, "") == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	if(strcmp(topath, querylist.at(0)) == 0) {
		dndok	= FALSE;
		goto cleardnd;
	}
	for(i = 0; i < count; i++) {
		if(strcmp(topath, querylist.at(i)) == 0) {
			fileopsErr("Error", SOUCDEST);
			dndok	= FALSE;
			goto cleardnd;
		}
	}
	sprintf(buff, "%s", topath);
	while(strcmp(buff, "/") != 0) {
		for(i = 0; i < count; i++) {
			if(strcmp(buff, querylist.at(i)) == 0) {
				fileopsErr("Error", SUBPATH);
				dndok	= FALSE;
				goto cleardnd;
			}
		}
		sprintf(buff, "%s", deleteLastPathComponent(buff));
	}
	
	query = (char*)malloc(count * MAX_PATH_LEN * sizeof(char));
	
	if(!isdragcopying)
		sprintf(query, "XWMoveOperation\n");
	else
		sprintf(query, "XWCopyOperation\n");
	
	sprintf(query, "%s%s\n%s\n", query, frompath, topath);
	for(i = 0; i < count; i++) {
		if(i == count -1)
			sprintf(query, "%s%s", query, lastPathComponent(querylist.at(i)));
		else
			sprintf(query, "%s%s\n", query, lastPathComponent(querylist.at(i)));
	}
	sendQueryToXWServer(FILEOPS, query);

	free(query);
	
cleardnd:
	fileListDragObj = NULL;
	fileDragObj = NULL;
	deskDragObj = NULL;

	deskobjmoving = FALSE;	
	xdnddone = TRUE;
	return;
}

void mfinderapp::propagatePathChangeInWins(char *oldpath, char *newpath)
{
	MFinderWin *win;
	DeskObj *dobj;
	char npath[MAX_PATH_LEN] = "";
	struct stat listStat;

	for(int i = 0; i < winlist.count(); i++) {
		win = winlist.at(i);
		if(lstat(win->myPath, &listStat)) { 
			if(isPathContainedInPath(win->myPath, oldpath)) {
				sprintf(npath, "%s%s", newpath, 
									subtractPathComponentToPath(win->myPath, oldpath));
				if(!lstat(npath, &listStat))
					win->changePathAndPropagate(npath);
				else 
					win->close();
			} else {
				win->close();
			}
		}
	}
	
	for(int i = 0; i < deskobjlist.count(); i++) {
		dobj = deskobjlist.at(i);
		if(lstat(dobj->myFullPath, &listStat)) { 
			if(isPathContainedInPath(dobj->myFullPath, oldpath)) {
				sprintf(npath, "%s%s", newpath, 
								subtractPathComponentToPath(dobj->myFullPath, oldpath));
				if(!lstat(npath, &listStat)) {
					int x = dobj->x;
					int y = dobj->y;
					removeDeskObjFromDict(dobj->myFullPath);
					deskobjlist.removeRef(dobj);
					makeDeskObjFromDrop(npath, x, y);
				} else {
					removeDeskObjFromDict(dobj->myFullPath);
					deskobjlist.removeRef(dobj);
				}
			} else {
				removeDeskObjFromDict(dobj->myFullPath);
				deskobjlist.removeRef(dobj);
			}
		}
	}	
	
}

void mfinderapp::newFileObject(MFinderWin *win, bool isdir)
{
	char filename[MAX_NAME_LEN] = "";
	char *query;

	if(access(win->myPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", win->myPath);
		fileopsErr("Error", ERR);
		return;
	}

	if(isdir)
		dialog = new Dialog(0L, "New Folder", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
	else
		dialog = new Dialog(0L, "New File", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");

	if(dialog->exec()) {
		sprintf(filename, "%s", dialog->editfield->text());
		for(int i = 0; i < cstrlen(filename); i++) {
			if(filename[i] == ' ' || filename[i] == '/' || filename[i] == '*'
				|| filename[i] == '(' || filename[i] == ')' || filename[i] == '['
				|| filename[i] == ']' || filename[i] == '{' || filename[i] == '}'
				|| filename[i] == '\\' || filename[i] == '<' || filename[i] == '>'
				|| filename[i] == '^' || filename[i] == '!' || filename[i] == '?'
				|| filename[i] == '$' || filename[i] == '&' || filename[i] == '#'
				|| filename[i] == '|' || filename[i] == '~' || filename[i] == '\"'
				|| filename[i] == '\'' || filename[i] == '`') {
				sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", filename[i]);
				fileopsErr("Error", ERR);
				return;
			}
		}
		
		query = (char*)malloc(MAX_PATH_LEN * sizeof(char));
		
		if(isdir)
			sprintf(query, "XWCreateDirOperation\n\n%s\n%s", win->myPath, filename);
		else
			sprintf(query, "XWCreateFileOperation\n\n%s\n%s", win->myPath, filename);

		sendQueryToXWServer(FILEOPS, query);
		free(query);
	}
}

void mfinderapp::removeFileObjects(MFinderWin *win)
{
	QPathList sortedlist;
	QStrList querylist;
	char *query = NULL;
	int i = 0, count = 0;
	
	if(strcmp(win->myPath, focusWin->myPath) != 0)
		return;
	
	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		count = selectedlist.count();

		if(count) {
			for(i = 0; i < count; i++)
				sortedlist.inSort(selectedlist.at(i)->myFullPath);

			int len = strlen(deleteLastPathComponent(sortedlist.at(0)));
			i = 0;
			while(strlen(deleteLastPathComponent(sortedlist.at(i))) == len) {
				querylist.append(sortedlist.at(i));
				i++;
				if(i == count)
					break;
			}

			if(count > querylist.count()) {
				sprintf(ERR, "You can't do this in multiple paths!\n");
				fileopsErr("Error", ERR);
				return;
			}

			count = querylist.count();

			query = (char*)malloc(count * MAX_PATH_LEN * sizeof(char));
			sprintf(query, "XWDestroyOperation\n\n%s\n", deleteLastPathComponent(querylist.at(0)));

			for(int i = 0; i < count; i++) {
				if(i == count -1)
					sprintf(query, "%s%s", query, lastPathComponent(querylist.at(i)));
				else
					sprintf(query, "%s%s\n", query, lastPathComponent(querylist.at(i)));
			}
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		QList<FileObj> selectedlist = oframe->selectedObjects();
		count = selectedlist.count();		

		if(count) {
			for(i = 0; i < count; i++)
				querylist.append(selectedlist.at(i)->myFullPath);

			query = (char*)malloc(count * MAX_PATH_LEN * sizeof(char));
			sprintf(query, "XWDestroyOperation\n\n%s\n", win->myPath);

			for(int i = 0; i < count; i++) {
				if(i == count -1)
					sprintf(query, "%s%s", query, lastPathComponent(querylist.at(i)));
				else
					sprintf(query, "%s%s\n", query, lastPathComponent(querylist.at(i)));
			}
		}
	}	
	
	if(query && count) {
		sendQueryToXWServer(FILEOPS, query);
		free(query);
	}
}

void mfinderapp::renameFileObjects(MFinderWin *win)
{
	char newpath[MAX_PATH_LEN] = "";
	char newname[MAX_NAME_LEN] = "";
	char buff[MAX_PATH_LEN] = "";
	bool noaccess = FALSE;
	bool isvalid;
	char *query;

	if(access(win->myPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", win->myPath);
		fileopsErr("Error", ERR);
		return;
	}

	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		FileListObj *fobj = selectedlist.at(0);
		isvalid = TRUE;
		dialog = new Dialog(0L, "Rename", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
		dialog->editfield->setText(fobj->myName);
		if(!dialog->exec()) 
			return;
		sprintf(newname, "%s", dialog->editfield->text());
		for(int h = 0; h < strlen(newname); h++) {
			if(newname[h] == ' ' || newname[h] == '/' || newname[h] == '*'
				|| newname[h] == '(' || newname[h] == ')' || newname[h] == '['
				|| newname[h] == ']' || newname[h] == '{' || newname[h] == '}'
				|| newname[h] == '\\' || newname[h] == '<' || newname[h] == '>'
				|| newname[h] == '^' || newname[h] == '!' || newname[h] == '?'
				|| newname[h] == '$' || newname[h] == '&' || newname[h] == '#'
				|| newname[h] == '|' || newname[h] == '~' || newname[h] == '\"'
				|| newname[h] == '\'' || newname[h] == '`') {
				isvalid = FALSE;
				sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", newname[h]);
				dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
				dialog->exec();
				return;
			}
		} 			
		if(isvalid) {
			if(strcmp(fobj->myPath, "/") == 0) 
				sprintf(newpath, "%s%s", fobj->myPath, newname);
			else
				sprintf(newpath, "%s/%s", fobj->myPath, newname);

			query = (char*)malloc(MAX_PATH_LEN * sizeof(char));
			sprintf(query, "XWRenameOperation\n%s\n%s", fobj->myFullPath, newpath);
		}

	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				isvalid = TRUE;
				dialog = new Dialog(0L, "Rename", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
				dialog->editfield->setText(fobj->myName);
				if(!dialog->exec()) 
					return;
				sprintf(newname, "%s", dialog->editfield->text());
				for(int h = 0; h < strlen(newname); h++) {
					if(newname[h] == ' ' || newname[h] == '/' || newname[h] == '*'
						|| newname[h] == '(' || newname[h] == ')' || newname[h] == '['
						|| newname[h] == ']' || newname[h] == '{' || newname[h] == '}'
						|| newname[h] == '\\' || newname[h] == '<' || newname[h] == '>'
						|| newname[h] == '^' || newname[h] == '!' || newname[h] == '?'
						|| newname[h] == '$' || newname[h] == '&' || newname[h] == '#'
						|| newname[h] == '|' || newname[h] == '~' || newname[h] == '\"'
						|| newname[h] == '\'' || newname[h] == '`') {
						isvalid = FALSE;
						sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", newname[h]);
						dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
						dialog->exec();
						return;
					}
				} 			
				if(isvalid) {
					if(strcmp(fobj->myPath, "/") == 0) 
						sprintf(newpath, "%s%s", fobj->myPath, newname);
					else
						sprintf(newpath, "%s/%s", fobj->myPath, newname);

					query = (char*)malloc(MAX_PATH_LEN * sizeof(char));
					sprintf(query, "XWRenameOperation\n%s\n%s", fobj->myFullPath, newpath);
				}
			}
		}
	}
	
	sendQueryToXWServer(FILEOPS, query);
	free(query);
}

void mfinderapp::duplicateFileObjects(MFinderWin *win)
{
	QPathList sortedlist;
	QStrList querylist;
	char *query;
	int i = 0, count = 0;
	
	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		count = selectedlist.count();

		for(i = 0; i < count; i++)
			sortedlist.inSort(selectedlist.at(i)->myFullPath);

		int len = strlen(deleteLastPathComponent(sortedlist.at(0)));
		i = 0;
		while(strlen(deleteLastPathComponent(sortedlist.at(i))) == len) {
			querylist.append(sortedlist.at(i));
			i++;
			if(i == count)
				break;
		}

		if(count > querylist.count()) {
			sprintf(ERR, "You can't do this in multiple paths!\n");
			fileopsErr("Error", ERR);
			return;
		}

		count = querylist.count();
		
		query = (char*)malloc(count * MAX_PATH_LEN * sizeof(char));
		sprintf(query, "XWDuplicateOperation\n%s\n%s\n", 
									deleteLastPathComponent(querylist.at(0)), 
											deleteLastPathComponent(querylist.at(0)));
		
		for(int i = 0; i < count; i++) {
			if(i == count -1)
				sprintf(query, "%s%s", query, lastPathComponent(querylist.at(i)));
			else
				sprintf(query, "%s%s\n", query, lastPathComponent(querylist.at(i)));
		}
		
	} else {
		ObjsFrame *oframe = win->objsframe;
		QList<FileObj> selectedlist = oframe->selectedObjects();
		count = selectedlist.count();		

		for(i = 0; i < count; i++)
			querylist.append(selectedlist.at(i)->myFullPath);
	
		query = (char*)malloc(count * MAX_PATH_LEN * sizeof(char));
		sprintf(query, "XWDuplicateOperation\n%s\n%s\n", win->myPath, win->myPath);
	
		for(int i = 0; i < count; i++) {
			if(i == count -1)
				sprintf(query, "%s%s", query, lastPathComponent(querylist.at(i)));
			else
				sprintf(query, "%s%s\n", query, lastPathComponent(querylist.at(i)));
		}
	}	
		
	sendQueryToXWServer(FILEOPS, query);
	free(query);
}

void mfinderapp::getFileAttributesAtPath(char *apath)
{
	char *query = (char*)malloc(MAX_PATH_LEN * sizeof(char));
	sprintf(query, "XWOpenInspectorsPanelOperation\n%s", apath);
	sendQueryToXWServer(FILEOPS, query);
	free(query);
}

void mfinderapp::Edit(MFinderWin *win)
{
	char query[MAX_PATH_LEN] = "";

	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
			if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
				sprintf(query, "%s\ndefaulteditor", fobj->myFullPath);
				sendQueryToXWServer(OPENFILEWITHAPP, query);
			}
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
					sprintf(query, "%s\ndefaulteditor", fobj->myFullPath);
					sendQueryToXWServer(OPENFILEWITHAPP, query);
				}
			}
		}
	}
}

void mfinderapp::OpenWith(MFinderWin *win)
{
	char query[MAX_PATH_LEN] = "";

	dialog = new Dialog(0L, "Open With...", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
	if(!dialog->exec())
		return;

	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
			if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
				char *cmd = strdup(dialog->editfield->text());
				sprintf(query, "%s\n%s", fobj->myFullPath, cmd);
				sendQueryToXWServer(OPENFILEWITHAPP, query);
				free(cmd);
			}
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect) {
				if(fobj->myType != DR &&  fobj->myType != DRLNK && 
								fobj->myType != FILLNK && fobj->myType != FILEXELNK) {
					char *cmd = strdup(dialog->editfield->text());
					sprintf(query, "%s\n%s", fobj->myFullPath, cmd);
					sendQueryToXWServer(OPENFILEWITHAPP, query);
					free(cmd);
				}
			}
		}
	}
}

void mfinderapp::StartXTerm(MFinderWin *win)
{
	sendQueryToXWServer(STARTXTERM, win->myPath);
}

void mfinderapp::InfoObj(MFinderWin *win)
{
	if(win->viewtype == BYNAME) {
		ObjsListFrame *oframe = win->objslistframe;
		QList<FileListObj> selectedlist = oframe->selectedObjects();
		for(int i = 0; i < selectedlist.count(); i++) {
			FileListObj *fobj = selectedlist.at(i);
				if(fobj->isSelect)
				 	fobj->InfoObj();
		}
	} else {
		ObjsFrame *oframe = win->objsframe;
		for(int i = 0; i < oframe->list.count(); i++) {
			FileObj *fobj = oframe->list.at(i);
			if(fobj->isSelect)
				fobj->InfoObj();
		}
	}
}

void mfinderapp::offixDrop(QWidget *drSource)
{
	char sourcepath[MAX_PATH_LEN] = "";
	int sourcetype;
	QPoint pnt = QCursor::pos();
	Window target = 0, DispatchWindow = 0;
	XEvent Event;
	int lx = 0, ly = 0;
	bool dooffixdrop = FALSE;

	if(drSource->inherits("FileObj")) {	
		sprintf(sourcepath, "%s", ((FileObj*)drSource)->myFullPath);
		sourcetype = ((FileObj*)drSource)->myType;
	} 
	if(drSource->inherits("FileListObj")) {	
		sprintf(sourcepath, "%s", ((FileListObj*)drSource)->myFullPath);
		sourcetype = ((FileListObj*)drSource)->myType;
	}
	if(drSource->inherits("DeskObj")) {	
		sprintf(sourcepath, "%s", ((DeskObj*)drSource)->myFullPath);
		sourcetype = ((DeskObj*)drSource)->myType;
	}

	if(!XTranslateCoordinates(qt_xdisplay(), qt_xrootwin(), 
											qt_xrootwin(), pnt.x(), 
											pnt.y(), &lx, &ly, &target)) 
		goto cleardnd;
	if(target) {
		QWidget *w = widgetAt(pnt, TRUE);
		if(w == NULL) 
			dooffixdrop = TRUE;
	} else {
		target = appRootWin;
		dooffixdrop = TRUE;
	}
	if(dooffixdrop) {
		if(sourcetype == FIL || sourcetype == FILEXE || sourcetype == DR) {
			if(sourcetype == FIL)
				DataType = 2;
			if(sourcetype == FILEXE)
				DataType = 7;
			if(sourcetype == DR)
				DataType = 5;

			XChangeProperty(dspl, DefaultRootWindow(dspl), 
								 DndSelection, XA_STRING, 8,
		    					 PropModeReplace, 
		    					 (unsigned char *)sourcepath, 
		    					 strlen(sourcepath)+1);

			DataOK = TRUE;
			
			if(!XTranslateCoordinates(dspl, desktop()->winId(), desktop()->winId(),
													pnt.x(), pnt.y(), &lx, &ly, &Target)) {
				DataOK = FALSE;
				goto cleardnd;
			}

			if(!Target) {
				if(deskobjmoving) {
					deskDragObj->move(pnt.x(), pnt.y());
					deskDragObj->x = pnt.x();
					deskDragObj->y = pnt.y();
					removeDeskObjFromDict(deskDragObj->myFullPath);
					addDeskObjToDict(deskDragObj);
				} else {
					if(drSource->inherits("FileObj")) 
						makeDeskObjFromDrop(((FileObj*)drSource)->myFullPath, pnt.x(), pnt.y());		
					if(drSource->inherits("FileListObj")) 
						makeDeskObjFromDrop(((FileListObj*)drSource)->myFullPath, pnt.x(), pnt.y());		
					if(drSource->inherits("DeskObj")) 
						makeDeskObjFromDrop(((DeskObj*)drSource)->myFullPath, pnt.x(), pnt.y());		
					DataOK = FALSE;
					goto cleardnd;    // makeDeskObj() se c'e' gia' non lo fa !
				}
			}
			
			DispatchWindow = Target;
			if(DataType == 2) {
				Event.xclient.type = ClientMessage;
				Event.xclient.display = dspl;
				Event.xclient.message_type = DndProtocol;
				Event.xclient.format = 32;
				Event.xclient.window = Target;
				Event.xclient.data.l[0] = DataType;
      		Event.xclient.data.l[1] = 0;
      		Event.xclient.data.l[2] = 0;
				Event.xclient.data.l[3] = pnt.x() + 65536L*(long)pnt.y();
				Event.xclient.data.l[4] = 1;
				XSendEvent(dspl, DispatchWindow, TRUE, NoEventMask, &Event);
			}
			DataOK = FALSE;
		}
	}
	
cleardnd:
	fileListDragObj = NULL;
	fileDragObj = NULL;
	deskDragObj = NULL;
	isdragcopying = FALSE;
	deskobjmoving = FALSE;	
	xdnddone = TRUE;	
}

void mfinderapp::makeDeskObjFromDrop(char *dropobjpath, int x, int y)
{
	struct stat listStat;
	int type;
	bool exist = FALSE;
	char name[MAX_NAME_LEN] = "", path[MAX_PATH_LEN] = "", fpath[MAX_PATH_LEN] = "";
	 
	for(int i = 0; i < deskobjlist.count(); i++)
		if(strcmp(deskobjlist.at(i)->myFullPath, dropobjpath) == 0)
			exist = TRUE;
	if(!exist) {
		strcpy(fpath, dropobjpath);
		strcpy(path, deleteLastPathComponent(fpath));
		strcpy(name, lastPathComponent(fpath));
	
   	lstat(fpath, &listStat);
		if(S_ISREG(listStat.st_mode)) {
			if(listStat.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))
				type = FILEXE;
			else
				type = FIL;
		}
		if(S_ISDIR(listStat.st_mode)) 
			type = DR;
		if(S_ISLNK(listStat.st_mode)) {
			if(chdir(fpath) != 0) {
				if(listStat.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH)) {
					type = FILEXELNK;
				} else {
					type = FILLNK;
				}
			} else {
				chdir(confdir);
				type = DRLNK;
			}
		}		
		if(S_ISCHR(listStat.st_mode)) 
			type = CHRDV;		
		if(S_ISBLK(listStat.st_mode)) 
			type = BLCKDV;	
		if(S_ISFIFO(listStat.st_mode)) 
			type = FIF;		
		if(S_ISSOCK(listStat.st_mode)) 
			type = SCKT;		

		deskobjlist.append(new DeskObj(0L, fpath, path, name, type, x, y));
		addDeskObjToDict(deskobjlist.current());
	}
}

void mfinderapp::makeDeskObjFromDictEntry(char *dictentry)
{
	char entry[2048] = "";
	char dsofullpath[MAX_PATH_LEN] = "";
	char dsopath[MAX_PATH_LEN] = "";
	char dsoname[MAX_NAME_LEN] = "";
	int dsotype, dsox, dsoy;
	char *token, *delims = "|";

	sprintf(entry, "%s", dictentry);
	token = strtok(entry, delims);
	strcpy(dsofullpath, token);
	token = strtok(NULL, delims);
	strcpy(dsopath, token);
	token = strtok(NULL, delims);
	strcpy(dsoname, token);
	token = strtok(NULL, delims);
	dsotype = atoi(token);
	token = strtok(NULL, delims);
	dsox = atoi(token);
	token = strtok(NULL, delims);
	dsoy = atoi(token);

	deskobjlist.append(new DeskObj(0L, dsofullpath, dsopath, dsoname, 
																		dsotype, dsox, dsoy));
	addDeskObjToDict(deskobjlist.current());
}

void mfinderapp::removeDeskObj(DeskObj *deskobj)
{
	int shFid = 0, shObid = 0;
	int m, t, q, k, sw, sh, x, y;
	short px[PIECES], py[PIECES];
	char pvx[PIECES], pvy[PIECES];
	char ax[PIECES], ay[PIECES];
	Display *scr;
	QPixmap Ptmp;

	Ptmp = QPixmap(deskobj->icona);
	Ptmp.detach();
	x = deskobj->pos().x();
	y = deskobj->pos().y();	

	removeDeskObjFromDict(deskobj->myFullPath);
	deskobjlist.removeRef(deskobj);

	scr = desktop()->x11Display();
	sw = desktop()->width();
	sh = desktop()->height();

	for(t=0, k=0; t < 48/PSIZE; t++) {
		for(q=0; q < 48/PSIZE; q++) {
	   	if(rand()%3) {
				ax[k] = t;
				ay[k] = q;
				px[k] = x + t * PSIZE;
				py[k] = y + q * PSIZE;
				pvx[k] = rand()%7 - 3;
				pvy[k] = -12 -rand()%6;
				k++;
	    	} else {
				ax[k] = -1;
	    	}
		}
	}
	q = k;
	while(k > 0) {
		for(t = 0; t < q; t++) {
	    	if(ax[t] >= 0) {
				px[t] += pvx[t];
				py[t] += pvy[t];
				pvy[t]++;
				if(px[t] < -48 || px[t] > sw || py[t] > sh) {
		    		ax[t] = -1;
		    		k--;
				} else {
		    		XCopyArea(scr, Ptmp.handle(), desktop()->winId(),
		    		DefaultGC(scr, 0),
			      						ax[t]*PSIZE, ay[t]*PSIZE, 
			      							PSIZE, PSIZE, px[t], py[t]);
				}
	    	}
		}
		for(t = 0; t < q; t++) {
			if(ax[t] >= 0) {
				XClearArea(scr, desktop()->winId(), px[t], py[t], PSIZE, PSIZE, 1);
	    	}
		}
	}
}
