#include "mfinderapp.h"
#include "functions.h"

char error[512] = "";
static char *NOPATH = "Invalid starting path!\n";
static char *NOQUERY = "You have not choosed an option!\n";
static char *NONUMSZ = "The \"size\" value is not a number!\n";
static char *NONUMTM = "one of the \"time\" values is not a number!\n";
static char *NODATE = "Invalid date!\n";

void mfinderapp::findFile(char *startpath)
{
	if(!isfinding) {
		findwin = new FindWin(0L, startpath);
		findwin->show();
		strcpy(findstartpath, startpath);
		isfinding = TRUE;
	}
}

void mfinderapp::parseFindQuery()
{
	char command[512] = "";
	char buff[64] = "";
	struct stat listStat;
	struct tm *data, finddata;
	time_t now, findtime;
	char dd[4] = "", mm[4] = "", yy[6] = "";
	double difft;
	char permstring[256] = "";
	int i, j, m;
	bool mustfind = TRUE, isnum = TRUE;

	isfinding = TRUE;
	
	if(lstat(findwin->controls->linEditStartAt->text(), &listStat)) {
	 	fileopsErr("Error", NOPATH);
		isfinding = FALSE;
		return;
	} else {
		sprintf(command, "find %s", findwin->controls->linEditStartAt->text());
	}

// -------------------------------- name ---------------------------------
	if(strcmp(findwin->controls->linEditName->text(), "") != 0) {
		switch(findwin->controls->cBoxName->currentItem()) { 
			case 0: 
				sprintf(command, "%s -name '*%s*'", command, findwin->controls->linEditName->text());
				break;
			case 1: 
				sprintf(command, "%s -name '%s'", command, findwin->controls->linEditName->text());
				break;
			case 2: 
				sprintf(command, "%s ! -name '*%s*'", command, findwin->controls->linEditName->text());
				break;
			case 3: 
				sprintf(command, "%s ! -name '%s'", command, findwin->controls->linEditName->text());
				break;
		}
	} else {
		mustfind = FALSE;
	}

// -------------------------------- type ---------------------------------
	if(strcmp(findwin->controls->cBoxType->currentText(), "any") != 0) {
		mustfind = TRUE;
		switch(findwin->controls->cBoxType->currentItem()) { 
			case 1: 
				sprintf(command, "%s -type 'f'", command);
				break;
			case 2: 
				sprintf(command, "%s -type 'd'", command);
				break;
			case 3: 
				sprintf(command, "%s -type 'l'", command);
				break;
			case 4: 
				sprintf(command, "%s -type 'b'", command);
				break;
			case 5: 
				sprintf(command, "%s -type 'c'", command);
				break;
			case 6: 
				sprintf(command, "%s -type 'p'", command);
				break;
			case 7: 
				sprintf(command, "%s -type 's'", command);
				break;
		}
	}

// -------------------------------- size ---------------------------------
	if(strcmp(findwin->controls->linEditSize->text(), "") != 0) {
		for(i = 0; i < strlen(findwin->controls->linEditSize->text()); i++) {
			if(!isdigit(findwin->controls->linEditSize->text()[i]))
				isnum = FALSE;
		}
		if(isnum) {
			mustfind = TRUE;
			switch(findwin->controls->cBoxSize->currentItem()) { 
				case 0: 
					sprintf(command, "%s -size +'%sk'", command, findwin->controls->linEditSize->text());
					break;
				case 1: 		
					sprintf(command, "%s -size -'%sk'", command, findwin->controls->linEditSize->text());
					break;
			}
		} else {
	 		fileopsErr("Error", NONUMSZ);
			isfinding = FALSE;
			return;
		}
	}

// -------------------------------- time ---------------------------------
	time(&now);
	data = localtime(&now);
	sprintf(mm, "%02i", data->tm_mon + 1);
	sprintf(dd, "%02i", data->tm_mday);
	sprintf(yy, "%02i", data->tm_year + 1900);
	
	if(strcmp(findwin->controls->linEditmm->text(), mm) != 0 
		|| strcmp(findwin->controls->linEditdd->text(), dd) != 0 
		|| strcmp(findwin->controls->linEdityy->text(), yy) != 0) {

		isnum = TRUE;
		for(i = 0; i < strlen(findwin->controls->linEditmm->text()); i++)
			if(!isdigit(findwin->controls->linEditmm->text()[i]))
				isnum = FALSE;
		for(i = 0; i < strlen(findwin->controls->linEditdd->text()); i++)
			if(!isdigit(findwin->controls->linEditdd->text()[i]))
				isnum = FALSE;
		for(i = 0; i < strlen(findwin->controls->linEdityy->text()); i++)
			if(!isdigit(findwin->controls->linEdityy->text()[i]))
				isnum = FALSE;
			
		if(!isnum) {
	 		fileopsErr("Error", NONUMTM);
			isfinding = FALSE;
			return;
		} else {
			if(atoi(findwin->controls->linEditmm->text()) > 12
						|| atoi(findwin->controls->linEditmm->text()) < 1)
	 			isnum = FALSE;
			if(atoi(findwin->controls->linEditdd->text()) > 31
						|| atoi(findwin->controls->linEditdd->text()) < 1)
	 			isnum = FALSE;
			if(atoi(findwin->controls->linEdityy->text()) > (data->tm_year + 1900)
						|| atoi(findwin->controls->linEdityy->text()) < 1970)
	 			isnum = FALSE;
			if(atoi(findwin->controls->linEdityy->text()) == (data->tm_year + 1900)
				&& atoi(findwin->controls->linEditmm->text()) > (data->tm_mon + 1))
	 			isnum = FALSE;
			if(atoi(findwin->controls->linEdityy->text()) == (data->tm_year + 1900)
				&& atoi(findwin->controls->linEditmm->text()) == (data->tm_mon + 1)
					&& atoi(findwin->controls->linEditdd->text()) > (data->tm_mday))
	 			isnum = FALSE;
			if(atoi(findwin->controls->linEditmm->text()) == 11
					|| atoi(findwin->controls->linEditmm->text()) == 4
					|| atoi(findwin->controls->linEditmm->text()) == 6
					|| atoi(findwin->controls->linEditmm->text()) == 9)
				if(atoi(findwin->controls->linEditdd->text()) > 30)
					isnum = FALSE;
			if(atoi(findwin->controls->linEditmm->text()) == 2)
				if(atoi(findwin->controls->linEditdd->text()) > 28)
					isnum = FALSE;

			if(!isnum) {
	 			fileopsErr("Error", NODATE);
				isfinding = FALSE;
				return;
			} else {
				mustfind = TRUE;
				
				finddata.tm_sec = 59;
				finddata.tm_min = 59;
				finddata.tm_hour = 23;
				finddata.tm_mday = atoi(findwin->controls->linEditdd->text());
				finddata.tm_mon = atoi(findwin->controls->linEditmm->text()) - 1;
				finddata.tm_year = atoi(findwin->controls->linEdityy->text()) - 1900;
				finddata.tm_isdst = -1;

				findtime = mktime(&finddata);
				difft = difftime(now, findtime) / 86400; // days
			
				switch(findwin->controls->cBoxTime->currentItem()) { 
					case 0: 
						switch(findwin->controls->cBoxWhen->currentItem()) { 
							case 0: 
								sprintf(command, "%s -atime +'%.0lf'", command, difft);
								break;
							case 1: 		
								sprintf(command, "%s -atime -'%.0lf'", command, difft);
								break;
						}
						break;
					case 1: 		
						switch(findwin->controls->cBoxWhen->currentItem()) { 
							case 0: 
								sprintf(command, "%s -ctime +'%.0lf'", command, difft);
								break;
							case 1: 		
								sprintf(command, "%s -ctime -'%.0lf'", command, difft);
								break;
						}
						break;
					case 2: 		
						switch(findwin->controls->cBoxWhen->currentItem()) { 
							case 0: 
								sprintf(command, "%s -mtime +'%.0lf'", command, difft);
								break;
							case 1: 		
								sprintf(command, "%s -mtime -'%.0lf'", command, difft);
								break;
						}
						break;
				}
			}
		}
	} 

// ------------------------------ permission -------------------------------
	if(findwin->controls->ureadchk->isChecked() || 
								findwin->controls->uwritechk->isChecked() ||
								findwin->controls->uexechk->isChecked() ||
								findwin->controls->uspecchk->isChecked() ||
								findwin->controls->greadchk->isChecked() ||
								findwin->controls->gwritechk->isChecked() ||
								findwin->controls->gexechk->isChecked() ||
								findwin->controls->gspecchk->isChecked() ||
								findwin->controls->oreadchk->isChecked() ||
								findwin->controls->owritechk->isChecked() ||
								findwin->controls->oexechk->isChecked() ||
								findwin->controls->ospecchk->isChecked()) {
			
		mustfind = TRUE;
		sprintf(permstring, "");
		
		if(findwin->controls->ureadchk->isChecked())
			sprintf(permstring, "%s -perm -u=r", permstring);
		if(findwin->controls->uwritechk->isChecked())
			sprintf(permstring, "%s -perm -u=w", permstring);
		if(findwin->controls->uexechk->isChecked())
			sprintf(permstring, "%s -perm -u=x", permstring);
		if(findwin->controls->uspecchk->isChecked())
			sprintf(permstring, "%s -perm -u=s", permstring);

		if(findwin->controls->greadchk->isChecked())
			sprintf(permstring, "%s -perm -g=r", permstring);
		if(findwin->controls->gwritechk->isChecked())
			sprintf(permstring, "%s -perm -g=w", permstring);
		if(findwin->controls->gexechk->isChecked())
			sprintf(permstring, "%s -perm -g=x", permstring);
		if(findwin->controls->gspecchk->isChecked())
			sprintf(permstring, "%s -perm -g=s", permstring);

		if(findwin->controls->oreadchk->isChecked())
			sprintf(permstring, "%s -perm -o=r", permstring);
		if(findwin->controls->owritechk->isChecked())
			sprintf(permstring, "%s -perm -o=w", permstring);
		if(findwin->controls->oexechk->isChecked())
			sprintf(permstring, "%s -perm -o=x", permstring);
		if(findwin->controls->ospecchk->isChecked())
			sprintf(permstring, "%s -perm -o=t", permstring);

		sprintf(command, "%s %s", command, permstring);
	}
	
// ------------------------------ owner -------------------------------
	if(strcmp(findwin->controls->linEditOwner->text(), "any") != 0) {
		mustfind = TRUE;
		sprintf(command, "%s -user '%s'", command, findwin->controls->linEditOwner->text());
	}

// ---------------------------- contents -----------------------------
	if(strcmp(findwin->controls->linEditContents->text(), "") != 0) {
		if(mustfind) {
			sprintf(command, "%s -print0 | xargs -r -0 grep -l %s", 
						command, findwin->controls->linEditContents->text());
		}
	}

// -------------------------------------------------------------------
	sprintf(command, "%s 2> /dev/null", command);

	if(mustfind) {
		doFind(command);
	} else {
	 	fileopsErr("Error", NOQUERY);
		isfinding = FALSE;
		return;
	}
}

void mfinderapp::doFind(char *command)
{
	char line[MAX_PATH_LEN] = "", fpath[MAX_PATH_LEN] = ""; 	
	FILE *fp;
	FindObj *obj = NULL;

	for(int i = findwin->findframe->list.count()-1; i >= 0 ; i--) {
		obj = findwin->findframe->list.at(i);
		findwin->findframe->list.removeRef(obj);
	}
	
	fp = popen(command, "r");
	if(fp != NULL) {
		while(fgets(line, sizeof(line), fp) != NULL) {
			processEvents();
			if(!isfinding)
				break;
			sprintf(fpath, "");
			for(int i = 0; i < strlen(line); i++) {
				if(line[i] != '\n') {
					fpath[i] = line[i];
				} else {
					fpath[i] = '\0';
					break;
				}
			}
			findwin->findframe->addAnObject(fpath);
			QResizeEvent e = QResizeEvent(findwin->findframe->size(), findwin->findframe->size());
			sendEvent(findwin->findframe, &e);
		}
	}
	pclose(fp);
}

void mfinderapp::stopFind()
{
	isfinding = FALSE;
}
