#include "findcontrols.h"
#include "mfinderapp.h"

extern char confdir[];
extern char iconsPath[];		 	
extern char appsPath[];

FindControls::FindControls(QWidget *parent, const char *startpath)
		  		 : QFrame(parent, startpath)
{
	char icnpath[MAX_PATH_LEN] = "";
	struct tm *data;
	time_t now;
	char dd[4] = "", mm[4] = "", yy[6] = "";
	 
	QColor x = QColor(160, 164, 160);
	QColorGroup CGnorm = QColorGroup(black, x, x.light(), x.dark(), 
																	x.dark(120), black, white);

	QColorGroup grigio = QColorGroup(QColor(QRgb(0)), QColor(QRgb(10527904)), QColor(QRgb(15791856)), 
													QColor(QRgb(5263952)), QColor(QRgb(6974826)), 
													QColor(QRgb(6579300)), QColor(QRgb(16777215)));

	font10 = QFont("Helvetica", 10);
	font12 = QFont("Helvetica", 12);

	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	
// -------------------------------- name ---------------------------------
	explName = new QLabel(this, "explName");
	explName->setGeometry(10, 5, 130, 20);
	explName->setPalette(QPalette(grigio, grigio, grigio));
	explName->setFont(font12);
	explName->setText("name");
	explName->setAlignment(289);

	cBoxName = new QComboBox(this, "cBoxName");
	cBoxName->setGeometry(10, 25, 130, 20);
	cBoxName->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	cBoxName->setFont(font12);
	cBoxName->insertItem("contains");
	cBoxName->insertItem("is");
	cBoxName->insertItem("doesn't contain");
	cBoxName->insertItem("is not");

	linEditName = new QLineEdit(this, "linEditName");
	linEditName->setGeometry(10, 50, 130, 20);
	linEditName->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditName->setFont(font12);
	linEditName->setText("");
	linEditName->setFrame(TRUE);

// -------------------------------- type ---------------------------------
	expType = new QLabel(this, "expType");
	expType->setGeometry(10, 80, 130, 20);
	expType->setPalette(QPalette(grigio, grigio, grigio));
	expType->setFont(font12);
	expType->setText("type");
	expType->setAlignment(289);

	cBoxType = new QComboBox(this, "cBoxType");
	cBoxType->setGeometry(10, 100, 130, 20);
	cBoxType->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	cBoxType->setFont(font12);
	cBoxType->insertItem("any");
	cBoxType->insertItem("regular file");
	cBoxType->insertItem("directory");
	cBoxType->insertItem("symbolic link");
	cBoxType->insertItem("block (buffered) special");
	cBoxType->insertItem("character (unbuffered) special");
	cBoxType->insertItem("named pipe (FIFO)");
	cBoxType->insertItem("socket");

// -------------------------------- size ---------------------------------
	explSize = new QLabel(this, "explSize");
	explSize->setGeometry(10, 125, 130, 20);
	explSize->setPalette(QPalette(grigio, grigio, grigio));
	explSize->setFont(font12);	
	explSize->setText("size (k)");
	explSize->setAlignment(289);

	cBoxSize = new QComboBox(this, "cBoxSize");
	cBoxSize->setGeometry(10, 145, 130, 20);
	cBoxSize->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	cBoxSize->setFont(font12);
	cBoxSize->insertItem("is greater than");
	cBoxSize->insertItem("is less than");

	linEditSize = new QLineEdit(this, "linEditSize");
	linEditSize->setGeometry(10, 170, 130, 20);
	linEditSize->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditSize->setFont(font12);
	linEditSize->setText("");
	linEditSize->setFrame(TRUE);

// -------------------------------- time ---------------------------------
	explTime = new QLabel(this, "explTime");
	explTime->setGeometry(155, 5, 130, 20);
	explTime->setPalette(QPalette(grigio, grigio, grigio));
	explTime->setFont(font12);
	explTime->setText("time");
	explTime->setAlignment(289);

	cBoxTime = new QComboBox(this, "cBoxTime");
	cBoxTime->setGeometry(155, 25, 130, 20);
	cBoxTime->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	cBoxTime->setFont(font12);
	cBoxTime->insertItem("accessed");
	cBoxTime->insertItem("changed the status");
	cBoxTime->insertItem("changed the contents");

	cBoxWhen = new QComboBox(this, "cBoxWhen");
	cBoxWhen->setGeometry(155, 50, 130, 20);
	cBoxWhen->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	cBoxWhen->setFont(font12);
	cBoxWhen->insertItem("before");
	cBoxWhen->insertItem("after");

	time(&now);
	data = localtime(&now);
	sprintf(mm, "%02i", data->tm_mon + 1);
	sprintf(dd, "%02i", data->tm_mday);
	sprintf(yy, "%02i", data->tm_year + 1900);
	
	linEditmm = new QLineEdit(this, "linEditmm");
	linEditmm->setGeometry(155, 75, 30, 20);
	linEditmm->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditmm->setFont(font12);
	linEditmm->setText(mm);
	linEditmm->setFrame(TRUE);

	linEditdd = new QLineEdit(this, "linEditdd");
	linEditdd->setGeometry(190, 75, 30, 20);
	linEditdd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditdd->setFont(font12);
	linEditdd->setText(dd);
	linEditdd->setFrame(TRUE);

	linEdityy = new QLineEdit(this, "linEdityy");
	linEdityy->setGeometry(225, 75, 60, 20);
	linEdityy->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEdityy->setFont(font12);
	linEdityy->setText(yy);
	linEdityy->setFrame(TRUE);

// ------------------------------ permission -------------------------------
	explPermiss = new QLabel(this, "explPermiss");
	explPermiss->setGeometry(155, 100, 130, 20);
	explPermiss->setPalette(QPalette(grigio, grigio, grigio));
	explPermiss->setFont(font12);
	explPermiss->setText("permission");
	explPermiss->setAlignment(289);

	userlab = new QLabel(this, "userlab");
	userlab->setGeometry(145, 135, 20, 20);
	userlab->setPalette(QPalette(grigio, grigio, grigio));
	userlab->setFont(font10);
	userlab->setText("U");
	userlab->setAlignment(290);

	groublab = new QLabel(this, "groublab");
	groublab->setGeometry(145, 155, 20, 20);
	groublab->setPalette(QPalette(grigio, grigio, grigio));
	groublab->setFont(font10);
	groublab->setText("G");
	groublab->setAlignment(290);

	otherslab = new QLabel(this, "otherslab");
	otherslab->setGeometry(145, 175, 20, 20);
	otherslab->setPalette(QPalette(grigio, grigio, grigio));
	otherslab->setFont(font10);
	otherslab->setText("O");
	otherslab->setAlignment(290);

	readlab = new QLabel(this, "readlab");
	readlab->setGeometry(165, 115, 30, 20);
	readlab->setPalette(QPalette(grigio, grigio, grigio));
	readlab->setFont(font10);
	readlab->setText("read");
	readlab->setAlignment(292);

	writelab = new QLabel(this, "writelab");
	writelab->setGeometry(190, 115, 30, 20);
	writelab->setPalette(QPalette(grigio, grigio, grigio));
	writelab->setFont(font10);
	writelab->setText("write");
	writelab->setAlignment(292);

	exelab = new QLabel(this, "exelab");
	exelab->setGeometry(215, 115, 30, 20);
	exelab->setPalette(QPalette(grigio, grigio, grigio));
	exelab->setFont(font10);
	exelab->setText("exec");
	exelab->setAlignment(292);

	speciallab = new QLabel(this, "speciallab");
	speciallab->setGeometry(240, 115, 30, 20);
	speciallab->setPalette(QPalette(grigio, grigio, grigio));
	speciallab->setFont(font10);
	speciallab->setText("spec");
	speciallab->setAlignment(292);

	uidlab = new QLabel(this, "uidlab");
	uidlab->setGeometry(265, 135, 30, 20);
	uidlab->setPalette(QPalette(grigio, grigio, grigio));
	uidlab->setFont(font10);
	uidlab->setText("UID");
	uidlab->setAlignment(289);

	gidlab = new QLabel(this, "gidlab");
	gidlab->setGeometry(265, 155, 30, 20);
	gidlab->setPalette(QPalette(grigio, grigio, grigio));
	gidlab->setFont(font10);
	gidlab->setText("GID");
	gidlab->setAlignment(289);

	stickylab = new QLabel(this, "stickylab");
	stickylab->setGeometry(265, 175, 30, 20);
	stickylab->setPalette(QPalette(grigio, grigio, grigio));
	stickylab->setFont(font10);
	stickylab->setText("Sticky");
	stickylab->setAlignment(289);

	ureadchk = new QCheckBox(this, "ureadchk");
	ureadchk->setGeometry(170, 135, 20, 20);
	ureadchk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	uwritechk = new QCheckBox(this, "uwritechk");
	uwritechk->setGeometry(195, 135, 20, 20);
	uwritechk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	uexechk = new QCheckBox(this, "uexechk");
	uexechk->setGeometry(220, 135, 20, 20);
	uexechk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	uspecchk = new QCheckBox(this, "uspecchk");
	uspecchk->setGeometry(245, 135, 20, 20);
	uspecchk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	greadchk = new QCheckBox(this, "greadchk");
	greadchk->setGeometry(170, 155, 20, 20);
	greadchk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	gwritechk = new QCheckBox(this, "gwritechk");
	gwritechk->setGeometry(195, 155, 20, 20);
	gwritechk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	gexechk = new QCheckBox(this, "gexechk");
	gexechk->setGeometry(220, 155, 20, 20);
	gexechk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	gspecchk = new QCheckBox(this, "gspecchk");
	gspecchk->setGeometry(245, 155, 20, 20);
	gspecchk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	oreadchk = new QCheckBox(this, "oreadchk");
	oreadchk->setGeometry(170, 175, 20, 20);
	oreadchk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	owritechk = new QCheckBox(this, "owritechk");
	owritechk->setGeometry(195, 175, 20, 20);
	owritechk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	oexechk = new QCheckBox(this, "oexechk");
	oexechk->setGeometry(220, 175, 20, 20);
	oexechk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	ospecchk = new QCheckBox(this, "ospecchk");
	ospecchk->setGeometry(245, 175, 20, 20);
	ospecchk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

// ------------------------------ owner -------------------------------
	explOwner = new QLabel(this, "explOwner");
	explOwner->setGeometry(300, 5, 130, 20);
	explOwner->setPalette(QPalette(grigio, grigio, grigio));
	explOwner->setFont(font12);
	explOwner->setText("owner");
	explOwner->setAlignment(289);

	linEditOwner = new QLineEdit(this, "linEditOwner");
	linEditOwner->setGeometry(300, 25, 130, 20);
	linEditOwner->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditOwner->setFont(font12);
	linEditOwner->setText("any");
	linEditOwner->setFrame(TRUE);
	
// ---------------------------- contents -----------------------------
	explContents = new QLabel(this, "explContents");
	explContents->setGeometry(300, 55, 130, 20);
	explContents->setPalette(QPalette(grigio, grigio, grigio));
	explContents->setFont(font12);
	explContents->setText("contents");
	explContents->setAlignment(289);

	linEditContents = new QLineEdit(this, "linEditContents");
	linEditContents->setGeometry(300, 75, 130, 20);
	linEditContents->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditContents->setFont(font12);
	linEditContents->setText("");
	linEditContents->setFrame(TRUE);

// ---------------------------- start at -----------------------------
	explStartAt = new QLabel(this, "explStartAt");
	explStartAt->setGeometry(300, 95, 130, 20);
	explStartAt->setPalette(QPalette(grigio, grigio, grigio));
	explStartAt->setFont(font12);
	explStartAt->setText("start at");
	explStartAt->setAlignment(289);

	linEditStartAt = new QLineEdit(this, "linEditStartAt");
	linEditStartAt->setGeometry(300, 115, 130, 20);
	linEditStartAt->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	linEditStartAt->setFont(font12);
	linEditStartAt->setText(startpath);
	linEditStartAt->setFrame(TRUE);

// ---------------------------- buttons -----------------------------
	buttOk = new QPushButton(this, "buttOk");
	buttOk->setGeometry(375, 145, 50, 50);
	buttOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttOk->setFont(font12);
	sprintf(icnpath, "%s/Magnify2.xpm", iconsPath);
	buttOk->setPixmap(QPixmap(icnpath, "XPM"));
	connect(buttOk, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(parseFindQuery()));

	buttCanc = new QPushButton(this, "buttCanc");
	buttCanc->setGeometry(310, 145, 50, 50);
	buttCanc->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttCanc->setFont(font12);
	sprintf(icnpath, "%s/HandOpen.xpm", iconsPath);
	buttCanc->setPixmap(QPixmap(icnpath, "XPM"));
	connect(buttCanc, SIGNAL(clicked()), ((mfinderapp *)qApp), SLOT(stopFind()));
}

void FindControls::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 1, width(), 1);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 2, width(), 2);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, height()-2, width(), height()-2);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, height()-1, width(), height()-1);
	p.end();
}
