#ifndef FINDFRAME_H
#define FINDFRAME_H

#include <qwidget.h>
#include <qpainter.h> 
#include <qframe.h> 
#include <qlist.h> 
#include <qstrlist.h> 
#include "common.h"
#include "findobj.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

class FindWin;

class FindFrame : public QWidget
{
	Q_OBJECT
public:
	FindFrame(QWidget *parent=0, const char *name=0);
	~FindFrame();
	FindWin *mywin;
	QList<FindObj> list; 
	char confdir[MAX_PATH_LEN];
	int VObjs;
	
	void addAnObject(char *);
	void unselectOtherObjects(FindObj *);

	bool isShiftClick;

signals:
	void resizeDone(int);
	
public slots:
	void selectAllObjects();
	void openSelectedObjects();
		
protected:
	void resizeEvent(QResizeEvent *);
	void mousePressEvent(QMouseEvent *);
	void paintEvent(QPaintEvent *);

private:

};

#endif // FINDFRAME_H
