#include "findwin.h"
#include "mfinderapp.h"

FindWin::FindWin(QWidget *parent, const char *startpath)
			  : QWidget(0L, 0L)
{
	setCaption("");
	setMinimumWidth(200);
	
	setGeometry(QRect(100,100,440,400));
	setFixedWidth(440);

	QColor x = QColor(160, 164, 160);
	QColorGroup CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, x);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	QFont fontbig = QFont("Helvetica", 18);

	titlebig = new QLabel(this, "titlebig");
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setFont(fontbig);
	titlebig->setText("find");
	titlebig->setAlignment(AlignLeft | AlignTop);
	
	sBar = new MfindScrBar(this, "barv");
	connect(sBar, SIGNAL(valueChanged(int)), this, SLOT(ScrollV(int)));
	YScrollBar = 0;
	
	findframe = new FindFrame(this, startpath);
	connect(findframe, SIGNAL(resizeDone(int)), this, SLOT(ResizeSBar(int)));
	findframe->lower();

	controls = new FindControls(this, startpath);

	show();
}

FindWin::~FindWin()
{

}

void FindWin::ScrollV(int y)
{
	YScrollBar = y;
	findframe->setGeometry(19, YScrollBar*(-1)+235, width()-19, height()-235+YScrollBar);
}

void FindWin::ResizeSBar(int y)
{
	if((y - height()+236) > 0)
		sBar->setRange(0, y - height()+236);
	else
		sBar->setRange(0, 1);
}

void FindWin::closeme()
{
	this->close();
}

void FindWin::resizeEvent(QResizeEvent *)
{
	titlebig->setGeometry(15, 5, width(), 25);
	
	controls->setGeometry(0, 30, width(), 205);	
	
	findframe->setGeometry(19, 235, width()-19, height()-235);
	sBar->setGeometry(1, 236, 18, height()-236);
	sBar->setValue(0);
	sBar->setSteps(20, height());
	
	((mfinderapp *)qApp)->centreDialogOnScreen(this);
}

void FindWin::closeEvent(QCloseEvent *e)
{
//	((mfinderapp *)qApp)->DirClose(myPath);

	((mfinderapp *)qApp)->isfinding = FALSE;

	this->~FindWin();  // Provvisorio !
}

void FindWin::keyPressEvent(QKeyEvent *e)
{
	if(e->state() == ControlButton) {
		switch(e->key()) { 
			case Key_W: 
				close();
				break;	
			case Key_O:
		//		((mfinderapp *)qApp)->openSelectedObjectsOfWin(this, FALSE);		
				break;
			case Key_A: 
				((mfinderapp *)qApp)->setOverrideCursor(waitCursor);
				findframe->selectAllObjects();
				((mfinderapp *)qApp)->restoreOverrideCursor();
				break;
			default:             
				e->ignore();
				return;
		} 				
	} else
		e->ignore();
}




