#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include <qobject.h> 
#include <qwidget.h> 
#include <qpixmapcache.h> 
#include <qimage.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qpainter.h>
#include <qfontmet.h> 
#include <qfont.h> 
#include <qcolor.h>
#include <qlist.h> 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

class FileObj;
class FileListObj;

//int QGList::compareItems(GCI item1, GCI item2);

char *deleteLastPathComponent(char *);
char *lastPathComponent(char *);
bool isPathContainedInPath(char *, char *);
char *subtractPathComponentToPath(char *, char *);

char *divideStringInLines(char *, int, char *, char, int);
bool isStringInString(char *, char *);
char *bestMatchingStringInArray(char **, int, char *);
char *bestMatchingPath(char *, char *);

bool isPlainFileAtPath(char *);

void loadAndTuneIcon(char *, char *);

void loadAndTuneFolderIcon(char *, char *);

int compare(const void *, const void *);
int create(char *, mode_t);
int rdel(char *, bool);
int copyfile(char *, char *);
int copydir(char *, char *);

int catchXError(Display *, XErrorEvent *);

#endif
