#ifndef MFINDERWIN_H
#define MFINDERWIN_H

#include <qapp.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qframe.h>
#include <qpopmenu.h> 
#include <qkeycode.h>
#include <qtimer.h> 
#include <qlist.h> 
#include "common.h"
#include "objsframe.h"
#include "objslistframe.h"
#include "fileobj.h"
#include "filelistobj.h"
#include "infoframe.h"
#include "mfindscrbar.h"

class MFinderWin : public QWidget
{
	Q_OBJECT
public:
	MFinderWin(QWidget *parent=0, const char *path=0, QRect *rect=0,
					bool dirfirst=FALSE, bool dotfiles=FALSE, int viewtype=0);
	~MFinderWin();

	char myPath[MAX_PATH_LEN];	
	bool dirfirst, dotfiles;
	int viewtype;
	
	ObjsFrame *objsframe;
	ObjsListFrame *objslistframe;
	MfindScrBar *sBar;
	int YScrollBar;
	InfoFrame *Info;
	char keybuff[16];
	int buffpos;
	bool iskeybuff;
	
	void scrollToSeeObjectAtPath(char*);
	void scrollUp(bool);
	void scrollDown(bool);
	void changePathAndPropagate(char*);
	void addKeyToKeysBuff(QKeyEvent *);
	
signals:		
	
public slots:
	void ScrollV(int);
	void ResizeSBar(int);
	void closeme();
	void changeViewByIcons();
	void changeViewBySmallIcons();
	void changeViewByName();
	void changeHideShowDotFiles();
	void timerDone();
		
protected:
	void resizeEvent(QResizeEvent *);
	void closeEvent(QCloseEvent *);
	void focusInEvent(QFocusEvent *);
	void keyPressEvent(QKeyEvent *);
	
private:

};

#endif // MFINDERWIN_H
