#ifndef OBJSFRAME_H
#define OBJSFRAME_H

#include <qwidget.h>
#include <qpainter.h> 
#include <qframe.h> 
#include <qlist.h> 
#include <qrect.h> 
#include <qdragobject.h>
#include <qdropsite.h>
#include <qstrlist.h> 
#include "popup.h"
#include "common.h"
#include "fileobj.h"
#include "deskobj.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

class MFinderWin;

class ObjsFrame : public QWidget, QDropSite
{
	Q_OBJECT
public:
	ObjsFrame(QWidget *parent=0, const char *path=0, 
							bool dirfirst=FALSE, bool dotfiles=FALSE, int viewtype=0);
	~ObjsFrame();
	MFinderWin *myfwin;
	QList<FileObj> list; 
	QList<FileObj> tmplist; 
	FileObj *objtokeep;
	
	void makeFileObjects();
	void addAnObject(char *);
	void removeAnObject(FileObj *);
	void updateContents();
	void makePopUp();
	void unselectOtherFileObjects(char *);
	void unselectAllFileObjects();
	FileObj* fileObjAtPath(char *);
	QStrList makeUrlList();
	QList<FileObj> selectedObjects();
	
	char myPath[MAX_PATH_LEN];
	bool isShiftClick, isDragShiftClick, isSelDragging, isDragTarget;
	bool dirfirst, dotfiles;
	int viewtype;
	bool closeme;

	Popup *globalPopUp;
	Popup *filePopUp;
	Popup *editPopUp;
	Popup *viewPopUp;
	Popup *specialPopUp;
	Popup *configPopUp;

	QRect SelRect;
	QPoint pBegSel;
	
signals:
	void resizeDone(int);
	void updateInfo();
	
public slots:
	void selectAllFileObjects();
	void changeNormalDirFirstSort();
	void newFolder();
	void newFile();
	void findFile();
	void openSelectedObjects();
	void newXTermAtMyPath();
			
protected:
	void resizeEvent(QResizeEvent *);
	void mousePressEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);
	void paintEvent(QPaintEvent *);
	void dragEnterEvent(QDragEnterEvent *);
	void dragLeaveEvent(QDragLeaveEvent *);
	void dropEvent(QDropEvent *);

private:

};

#endif // OBJSFRAME_H
