#ifndef OBJSFRAMELIST_H
#define OBJSFRAMELIST_H

#include <qwidget.h>
#include <qpainter.h> 
#include <qframe.h> 
#include <qlist.h> 
#include <qrect.h> 
#include <qdragobject.h>
#include <qdropsite.h>
#include <qstrlist.h> 
#include "popup.h"
#include "common.h"
#include "filelistobj.h"
#include "deskobj.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

class MFinderWin;

class ObjsListFrame : public QWidget, QDropSite
{
	Q_OBJECT
public:
	ObjsListFrame(QWidget *parent=0, const char *path=0, 
										bool dirfirst=FALSE, bool dotfiles=FALSE);
	~ObjsListFrame();
	MFinderWin *myfwin;
	QList<FileListObj> list; 
	QList<FileListObj> allobjslist; 
	FileListObj *objtokeep;
	int VObjs;
	int labelsshift;
	
	void makeFileObjects();
	void addAnObject(char *);
	void removeAnObject(FileListObj *);
	void updateContents();	
	void makePopUp();
	void unselectOtherFileObjects(char *, bool);
	void unselectAllFileObjects();
	FileListObj* fileObjAtPath(char *);
	FileListObj* fileObjInTreeAtPath(char *);
	QStrList makeUrlList();
	void addToUrlList(QStrList *, FileListObj *);
	QList<FileListObj> selectedObjects();
	void addToSelectedList(QList<FileListObj> *, FileListObj *);

	char myPath[MAX_PATH_LEN];
	bool isShiftClick, isDragShiftClick, isSelDragging, isDragTarget;
	bool dirfirst, dotfiles;

	Popup *popupMenu;
	Popup *globalPopUp;
	Popup *filePopUp;
	Popup *editPopUp;
	Popup *viewPopUp;
	Popup *specialPopUp;
	Popup *configPopUp;

	QRect SelRect;
	QPoint pBegSel;
	
signals:
	void resizeDone(int);
	void updateInfo();
	
public slots:
	void selectAllFileObjects();
	void changeNormalDirFirstSort();
	void newFolder();
	void newFile();
	void findFile();
	void openSelectedObjects();
	void newXTermAtMyPath();
		
protected:
	void resizeEvent(QResizeEvent *);
	void mousePressEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);	
	void paintEvent(QPaintEvent *);
	void dragEnterEvent(QDragEnterEvent *);
	void dragLeaveEvent(QDragLeaveEvent *);
	void dropEvent(QDropEvent *);

private:
	void objectPosition(FileListObj *);

};

#endif // OBJSFRAMELIST_H
